## pycryptodome 3.9.7+dfsg1

=== src/test/Makefile ===
CPPFLAGS += -I.. $(shell python -c "from __future__ import print_function; import sys; print('-DPYCRYPTO_' + sys.byteorder.upper() + '_ENDIAN')")
CPPFLAGS += -DHAVE_POSIX_MEMALIGN -DHAVE_STDINT_H
CPPFLAGS += -DSTATIC=""
CFLAGS += -O3 -g -fstrict-aliasing -Wall -Werror

TAPPS:=tests_addmul128_32 tests_addmul128_64 tests_square_32 tests_square_64 tests_product tests_addmul test_endianess\
       test_poly1305_reduce test_poly1305_load_r test_poly1305_load_m test_poly1305_multiply test_poly1305_accumulate\
	   test_mont tests_mont_mult tests_ec_ws_64 tests_ec_ws_32

ifneq (,$(filter $(shell uname -m),x86_64 i386 i686))
CPPFLAGS += -DHAVE_X86INTRIN_H -DUSE_SSE2 -DHAVE_WMMINTRIN_H -DHAVE_TMMINTRIN_H
CFLAGS += -msse2
TAPPS += test_clmul
endif

ifeq (64bit, $(shell python -c "from __future__ import print_function; import platform; print(platform.architecture()[0])"))
CPPFLAGS += -DHAVE_UINT128
endif

CPPFLAGS += $(UNDEFS)

TGTS:=$(foreach t,$(TAPPS),build/$t)

UTILS=build/modexp_utils.o build/siphash.o

test: build ${TGTS}
	set -e && for t in ${TGTS}; do $$t; done

build:
	mkdir build

all: ${$TGTS}

clean:
	rm -fr build common.pyc

# utils

build/siphash.o: ../siphash.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) -o $@ $^

build/modexp_utils.o: ../modexp_utils.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) -o $@ $^

# ECC

build/tests_ec_ws_64: test_ec_ws.c ../ec_ws.c build/mont_64.o $(UTILS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^

build/tests_ec_ws_32: test_ec_ws.c ../ec_ws.c build/mont_32.o $(UTILS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=32 -UHAVE_UINT128

# addmul128

build/tests_addmul128.c: make_tests_addmul128.py
	python $^ > $@

build/tests_addmul128_32: build/tests_addmul128.c ../multiply_32.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^

build/tests_addmul128_64: build/tests_addmul128.c ../multiply_64.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^

# square

build/tests_square.c: make_tests_square.py
	python $^ > $@

build/tests_square_32: build/tests_square.c ../multiply_32.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^

build/tests_square_64: build/tests_square.c ../multiply_64.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^

# endianess

build/test_endianess: test_endianess.c ../common.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $<

# clmul

build/clmul.o: ../ghash_clmul.c
	$(CC) $(CFLAGS) -mssse3 -mpclmul $(CPPFLAGS) -o $@ $< -c

build/test_clmul: test_clmul.c ../common.h build/clmul.o
	$(CC) $(CFLAGS) -mssse3 -mpclmul $(CPPFLAGS) -o $@ $(filter %.c %.o, $^)

# Poly1305

build/poly1305.o: ../poly1305.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -c

build/test_poly1305_reduce.c: make_tests_poly1305_reduce.py
	python $^ > $@

build/test_poly1305_load_r.c: make_tests_poly1305_load_r.py
	python $^ > $@

build/test_poly1305_load_m.c: make_tests_poly1305_load_m.py
	python $^ > $@

build/test_poly1305_multiply.c: make_tests_poly1305_multiply.py
	python $^ > $@

build/test_poly1305_accumulate.c: make_tests_poly1305_accumulate.py
	python $^ > $@

build/test_poly1305_reduce: build/test_poly1305_reduce.c ../common.h build/poly1305.o
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $(filter %.c %.o, $^)

build/test_poly1305_load_r: build/test_poly1305_load_r.c ../common.h build/poly1305.o
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $(filter %.c %.o, $^)

build/test_poly1305_load_m: build/test_poly1305_load_m.c ../common.h build/poly1305.o
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $(filter %.c %.o, $^)

build/test_poly1305_multiply: build/test_poly1305_multiply.c ../common.h build/poly1305.o
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $(filter %.c %.o, $^)

build/test_poly1305_accumulate: build/test_poly1305_accumulate.c ../common.h build/poly1305.o
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $(filter %.c %.o, $^)

# Montgomery

build/mont_32.o: ../mont.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=32 -UHAVE_UINT128

build/mont_64.o: ../mont.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=64

build/test_mont: test_mont.c ../common.h build/mont_32.o $(UTILS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $(filter %.c %.o, $^)

build/tests_addmul.c: make_tests_addmul.py
	python $^ > $@

build/tests_addmul: build/tests_addmul.c build/mont_32.o $(UTILS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^

build/tests_product.c: make_tests_product.py
	python $^ > $@

build/tests_product: build/tests_product.c build/mont_32.o $(UTILS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^

build/tests_mont_mult.c: make_tests_mont_mult.py
	python $^ > $@

build/tests_mont_mult: build/tests_mont_mult.c build/mont_32.o $(UTILS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^

## pycryptodome 3.4.6

=== debian/changelog ===
pycryptodome (3.4.6-1) unstable; urgency=low

  * source package automatically created by stdeb 0.8.5
  * Initial release. (Closes: #864294: ITP: pycryptodome --
    cryptographic library for Python)

 -- Christopher Hoskin <mans0954@debian.org>  Sun, 11 Jun 2017 20:51:56 +0100

=== debian/control ===
Source: pycryptodome
Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Uploaders: Christopher Hoskin <mans0954@debian.org>
Section: python
Priority: optional
Build-Depends: dh-python, python-setuptools, python3-setuptools, python-all-dev, python3-all-dev, debhelper (>= 9),
 python3-sphinx
Standards-Version: 3.9.8
Homepage: http://www.pycryptodome.org
Vcs-Git: https://anonscm.debian.org/git/python-modules/packages/pycryptodome.git
Vcs-Browser: https://anonscm.debian.org/git/python-modules/packages/pycryptodome.git

Package: python-pycryptodome
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Description: cryptographic Python library (Python 2)
 PyCryptodome is a self-contained Python package of low-level
 cryptographic primitives.
 .
 PyCryptodome is a fork of PyCrypto. It brings several enhancements
 with respect to the last official version of PyCrypto (2.6.1),
 for instance:
 .
   * Authenticated encryption modes (GCM, CCM, EAX, SIV, OCB)
   * Accelerated AES on Intel platforms via AES-NI
   * First class support for PyPy
   * Elliptic curves cryptography (NIST P-256 curve only)
   * Better and more compact API (`nonce` and `iv` attributes for ciphers,
     automatic generation of random nonces and IVs, simplified CTR cipher mode,
     and more)
   * SHA-3 (including SHAKE XOFs) and BLAKE2 hash algorithms
   * Salsa20 and ChaCha20 stream ciphers
   * scrypt and HKDF
   * Deterministic (EC)DSA
   * Password-protected PKCS#8 key containers
   * Shamir's Secret Sharing scheme
   * Random numbers get sourced directly from the OS (and not from a CSPRNG in
     userspace)
   * Simplified install process, including better support for Windows
   * Cleaner RSA and DSA key generation (largely based on FIPS 186-4)
   * Major clean ups and simplification of the code base
 .
 PyCryptodome is not a wrapper to a separate C library like *OpenSSL*.
 To the largest possible extent, algorithms are implemented in pure Python.
 Only the pieces that are extremely critical to performance (e.g. block ciphers)
 are implemented as C extensions.
 .
 This is the Python 2 version of the package.

Package: python3-pycryptodome
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: cryptographic Python library (Python 3)
 PyCryptodome is a self-contained Python package of low-level
 cryptographic primitives.
 .
 PyCryptodome is a fork of PyCrypto. It brings several enhancements
 with respect to the last official version of PyCrypto (2.6.1),
 for instance:
 .
   * Authenticated encryption modes (GCM, CCM, EAX, SIV, OCB)
   * Accelerated AES on Intel platforms via AES-NI
   * First class support for PyPy
   * Elliptic curves cryptography (NIST P-256 curve only)
   * Better and more compact API (`nonce` and `iv` attributes for ciphers,
     automatic generation of random nonces and IVs, simplified CTR cipher mode,
     and more)
   * SHA-3 (including SHAKE XOFs) and BLAKE2 hash algorithms
   * Salsa20 and ChaCha20 stream ciphers
   * scrypt and HKDF
   * Deterministic (EC)DSA
   * Password-protected PKCS#8 key containers
   * Shamir's Secret Sharing scheme
   * Random numbers get sourced directly from the OS (and not from a CSPRNG in
     userspace)
   * Simplified install process, including better support for Windows
   * Cleaner RSA and DSA key generation (largely based on FIPS 186-4)
   * Major clean ups and simplification of the code base
 .
 PyCryptodome is not a wrapper to a separate C library like *OpenSSL*.
 To the largest possible extent, algorithms are implemented in pure Python.
 Only the pieces that are extremely critical to performance (e.g. block ciphers)
 are implemented as C extensions.
 .
 This is the Python 3 version of the package.

Package: python-pycryptodome-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: cryptographic Python library (documentation)
 PyCryptodome is a self-contained Python package of low-level
 cryptographic primitives.
 .
 PyCryptodome is a fork of PyCrypto. It brings several enhancements
 with respect to the last official version of PyCrypto (2.6.1),
 for instance:
 .
   * Authenticated encryption modes (GCM, CCM, EAX, SIV, OCB)
   * Accelerated AES on Intel platforms via AES-NI
   * First class support for PyPy
   * Elliptic curves cryptography (NIST P-256 curve only)
   * Better and more compact API (`nonce` and `iv` attributes for ciphers,
     automatic generation of random nonces and IVs, simplified CTR cipher mode,
     and more)
   * SHA-3 (including SHAKE XOFs) and BLAKE2 hash algorithms
   * Salsa20 and ChaCha20 stream ciphers
   * scrypt and HKDF
   * Deterministic (EC)DSA
   * Password-protected PKCS#8 key containers
   * Shamir's Secret Sharing scheme
   * Random numbers get sourced directly from the OS (and not from a CSPRNG in
     userspace)
   * Simplified install process, including better support for Windows
   * Cleaner RSA and DSA key generation (largely based on FIPS 186-4)
   * Major clean ups and simplification of the code base
 .
 PyCryptodome is not a wrapper to a separate C library like *OpenSSL*.
 To the largest possible extent, algorithms are implemented in pure Python.
 Only the pieces that are extremely critical to performance (e.g. block ciphers)
 are implemented as C extensions.
 .
 This is the documentation package.

=== debian/watch ===
version=3
opts=uversionmangle=s/(rc|a|b|c)/~$1/,pgpsigurlmangle=s/$/.asc/ \
http://pypi.debian.net/pycryptodome/pycryptodome-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## pycryptodome 3.4.7

=== debian/changelog ===
pycryptodome (3.4.7-1ubuntu1) bionic; urgency=medium

  * SECURITY UPDATE: weak ElGamal key parameters
    - debian/patches/CVE-2018-6594.patch: choose a square residue in
      lib/Crypto/PublicKey/ElGamal.py.
    - CVE-2018-6594

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 06 Apr 2018 08:35:25 -0400

pycryptodome (3.4.7-1) unstable; urgency=medium

  * New upstream release (3.4.7)
  * Use secure URI in debian/watch
  * Remove new-package-should-not-package-python2-module lintian override
  * Update extra-license-file lintian override (Sphinx now appears to create a
    copy of the source file with extension rst.txt)
  * Bump Standards-Version from 3.9.8 to 4.1.1 (no change required)
  * Add missing build dependency on python3-sphinx-rtd-theme

 -- Christopher Hoskin <mans0954@debian.org>  Sat, 04 Nov 2017 10:24:18 +0000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: pycryptodome
-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Uploaders: Christopher Hoskin <mans0954@debian.org>
 Section: python
 Priority: optional
 Build-Depends: dh-python, python-setuptools, python3-setuptools, python-all-dev, python3-all-dev, debhelper (>= 9),
- python3-sphinx
-Standards-Version: 3.9.8
+ python3-sphinx, python3-sphinx-rtd-theme
+Standards-Version: 4.1.1
 Homepage: http://www.pycryptodome.org
 Vcs-Git: https://anonscm.debian.org/git/python-modules/packages/pycryptodome.git
 Vcs-Browser: https://anonscm.debian.org/git/python-modules/packages/pycryptodome.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PYBUILD_NAME=pycryptodome
export PYBUILD_BEFORE_BUILD=touch .separate_namespace
export PYBUILD_AFTER_INSTALL=rm '{destdir}/{install_dir}/Cryptodome/SelfTest/PublicKey/test_vectors/ECC/gen_ecc_p256.sh'
%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_test:
	PYBUILD_SYSTEM=custom \
        PYBUILD_TEST_ARGS="python{version} -m Cryptodome.SelfTest {build_dir}/" dh_auto_test

override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=. sphinx-build -N -bhtml Doc/ build/html # HTML generator
	PYTHONPATH=. sphinx-build -N -bman Doc/ build/man # Manpage generator

=== debian/tests/control ===
Test-Command: set -e ; for py in $(pyversions -r 2>/dev/null) ; do cd "$ADTTMP" ; echo "Testing with $py:" ; $py -c "import Cryptodome; print Cryptodome" ; done
Depends: python-all, python-pycryptodome

Test-Command: set -e ; for py in $(py3versions -r 2>/dev/null) ; do cd "$ADTTMP" ; echo "Testing with $py:" ; $py -c "import Cryptodome; print(Cryptodome)" ; done
Depends: python3-all, python3-pycryptodome

=== debian/watch ===
version=3
opts=uversionmangle=s/(rc|a|b|c)/~$1/,pgpsigurlmangle=s/$/.asc/ \
https://pypi.debian.net/pycryptodome/pycryptodome-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## pycryptodome 3.4.11

=== debian/changelog ===
pycryptodome (3.4.11-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ Christopher Hoskin ]
  * Fix "CVE-2018-6594" Resolved by upstream in 3.4.10 (Closes:
    #889998)
  * Add upstream metadata file
  * Add 0003-Fix-syntax-error.patch
  * Add lib/Cryptodome/ to clean
  * Bump debhelper compat from 9 to 11
  * Keep the documentation in python-pycryptodome-doc (for now at least)
  * Bump Standards-Version from 4.1.1 to 4.1.3 (no change required)

 -- Christopher Hoskin <mans0954@debian.org>  Tue, 06 Mar 2018 07:02:32 +0000

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: pycryptodome
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
+Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Uploaders: Christopher Hoskin <mans0954@debian.org>
 Section: python
 Priority: optional
-Build-Depends: dh-python, python-setuptools, python3-setuptools, python-all-dev, python3-all-dev, debhelper (>= 9),
+Build-Depends: dh-python, python-setuptools, python3-setuptools, python-all-dev, python3-all-dev, debhelper (>= 11),
  python3-sphinx, python3-sphinx-rtd-theme
-Standards-Version: 4.1.1
+Standards-Version: 4.1.3
 Homepage: http://www.pycryptodome.org
-Vcs-Git: https://anonscm.debian.org/git/python-modules/packages/pycryptodome.git
-Vcs-Browser: https://anonscm.debian.org/git/python-modules/packages/pycryptodome.git
+Vcs-Git: https://salsa.debian.org/python-team/modules/pycryptodome.git
+Vcs-Browser: https://salsa.debian.org/python-team/modules/pycryptodome
 
 Package: python-pycryptodome
 Architecture: any

## pycryptodome 3.6.1

=== debian/changelog ===
pycryptodome (3.6.1-3) unstable; urgency=medium

  * Backport to Debian 9

 -- SaltStack Packaging Team <packaging@saltstack.com>  Wed, 10 Jun 2020 17:21:57 -0600

pycryptodome (3.6.1-2) unstable; urgency=medium

  * Bump Standards-Version from 4.1.3 to 4.1.4.
  * Refresh 0003-Fix-syntax-error.patch.
  * Updated 2000-backport-to-stretch.patch with more changes needed in Stretch.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 12 Jun 2018 12:04:57 +0200

pycryptodome (3.6.1-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/tests: Use AUTOPKGTEST_TMP instead of ADTTMP

  [ Petter Reinholdtsen ]
  * New upstream release 3.6.1.
    - Solve build problem on 32 bits big endian archs (Closes: #892175).
  * Ran wrap-and-sort.
  * Add d/gbp.conf to enforce the use of pristine-tar.
  * Added 2000-backport-to-stretch.patch documenting a way to backport
    to Debian Stretch.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 12 Jun 2018 08:22:26 +0000

=== debian/control ===
Source: pycryptodome
Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Uploaders: Christopher Hoskin <mans0954@debian.org>
Section: python
Priority: optional
Build-Depends: debhelper (>= 10),
               dh-python,
               python-all-dev,
               python-setuptools,
               python3-all-dev,
               python3-setuptools,
               python3-sphinx,
               python3-sphinx-rtd-theme
Standards-Version: 3.9.8
Homepage: http://www.pycryptodome.org
Vcs-Git: https://salsa.debian.org/python-team/modules/pycryptodome.git
Vcs-Browser: https://salsa.debian.org/python-team/modules/pycryptodome


Package: python3-pycryptodome
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: cryptographic Python library (Python 3)
 PyCryptodome is a self-contained Python package of low-level
 cryptographic primitives.
 .
 PyCryptodome is a fork of PyCrypto. It brings several enhancements
 with respect to the last official version of PyCrypto (2.6.1),
 for instance:
 .
   * Authenticated encryption modes (GCM, CCM, EAX, SIV, OCB)
   * Accelerated AES on Intel platforms via AES-NI
   * First class support for PyPy
   * Elliptic curves cryptography (NIST P-256 curve only)
   * Better and more compact API (`nonce` and `iv` attributes for ciphers,
     automatic generation of random nonces and IVs, simplified CTR cipher mode,
     and more)
   * SHA-3 (including SHAKE XOFs) and BLAKE2 hash algorithms
   * Salsa20 and ChaCha20 stream ciphers
   * scrypt and HKDF
   * Deterministic (EC)DSA
   * Password-protected PKCS#8 key containers
   * Shamir's Secret Sharing scheme
   * Random numbers get sourced directly from the OS (and not from a CSPRNG in
     userspace)
   * Simplified install process, including better support for Windows
   * Cleaner RSA and DSA key generation (largely based on FIPS 186-4)
   * Major clean ups and simplification of the code base
 .
 PyCryptodome is not a wrapper to a separate C library like *OpenSSL*.
 To the largest possible extent, algorithms are implemented in pure Python.
 Only the pieces that are extremely critical to performance (e.g. block ciphers)
 are implemented as C extensions.
 .
 This is the Python 3 version of the package.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DH_OPTIONS=-v

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PYBUILD_NAME=pycryptodome
export PYBUILD_BEFORE_BUILD=touch .separate_namespace
export PYBUILD_AFTER_INSTALL=rm '{destdir}/{install_dir}/Cryptodome/SelfTest/PublicKey/test_vectors/ECC/gen_ecc_p256.sh'
%:
	dh $@ --with python3 --buildsystem=pybuild
##	dh $@ --with python2,python3,sphinxdoc --buildsystem=pybuild

##override_dh_auto_test:
##	PYBUILD_SYSTEM=custom \
##        PYBUILD_TEST_ARGS="python{version} -m Cryptodome.SelfTest {build_dir}/" dh_auto_test

override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	dh_auto_build
##	PYTHONPATH=. sphinx-build -N -bhtml Doc/ build/html # HTML generator
##	PYTHONPATH=. sphinx-build -N -bman Doc/ build/man # Manpage generator
##
### Do this until it becomes clearer where documentation should live post Python 2
##override_dh_installdocs:
##	dh_installdocs -p python-pycryptodome
##	dh_installdocs -p python3-pycryptodome
##	dh_installdocs --doc-main-package=python-pycryptodome-doc -p python-pycryptodome-doc

## pycryptodome 3.9.7%2Bdfsg1

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PYBUILD_NAME=pycryptodome

# DESTDIR export variable is used hereunder in execute_after_dh_auto_install
export DESTDIR=$(CURDIR)/debian/python3-pycryptodome
py3versions = $(shell py3versions -rv)

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_test:
	PYBUILD_SYSTEM=custom \
        PYBUILD_TEST_ARGS="python{version} -m Cryptodome.SelfTest {build_dir}/" dh_auto_test

execute_before_dh_auto_build:
	export http_proxy=127.0.0.1:9
	export https_proxy=127.0.0.1:9
	touch .separate_namespace

execute_after_dh_auto_build:
	PYTHONPATH=. python3 -m sphinx -N -bhtml Doc/ build/html # HTML generator
	PYTHONPATH=. python3 -m sphinx -N -bman Doc/ build/man # Manpage generator

# Do this until it becomes clearer where documentation should live post Python 2
override_dh_installdocs:
	dh_installdocs -p python3-pycryptodome
	dh_installdocs --doc-main-package=python-pycryptodome-doc -p python-pycryptodome-doc

execute_after_dh_auto_install:
	set -e ; for pyver in $(py3versions); do \
		rm $(DESTDIR)/usr/lib/python$$pyver/dist-packages/Cryptodome/SelfTest/Cipher/test_vectors/AES/README.txt; \
		rm $(DESTDIR)/usr/lib/python$$pyver/dist-packages/Cryptodome/SelfTest/Cipher/test_vectors/TDES/README.txt; \
		rm $(DESTDIR)/usr/lib/python$$pyver/dist-packages/Cryptodome/SelfTest/Hash/test_vectors/keccak/readme.txt; \
		rm $(DESTDIR)/usr/lib/python$$pyver/dist-packages/Cryptodome/SelfTest/Signature/test_vectors/ECDSA/README.txt; \
		rm $(DESTDIR)/usr/lib/python$$pyver/dist-packages/Cryptodome/SelfTest/PublicKey/test_vectors/ECC/gen_ecc_p256.sh; \
		rm $(DESTDIR)/usr/lib/python$$pyver/dist-packages/Cryptodome/SelfTest/PublicKey/test_vectors/ECC/gen_ecc_p384.sh; \
		rm $(DESTDIR)/usr/lib/python$$pyver/dist-packages/Cryptodome/SelfTest/PublicKey/test_vectors/ECC/gen_ecc_p521.sh; \
		rm $(DESTDIR)/usr/lib/python$$pyver/dist-packages/Cryptodome/SelfTest/PublicKey/test_vectors/RSA/gen_rsa_2048.sh; \
	done

## pycryptodome 3.9.7+dfsg1

=== debian/changelog ===
pycryptodome (3.9.7+dfsg1-1) unstable; urgency=medium

  [ Emmanuel Arias ]
  * Team upload.
  * New upstream version 3.9.7 (Closes: #956046).
  * d/contol: debhelper-compat to 13 (from 11),
  * d/control: Bump Standard-Version to 4.5.0 (no changes).
  * d/gbp.conf: Set debian/master as default branch.
  * d/salsa-ci.yml: enable salsa-ci.
  * Remove patch that has been upstreamed 0003-Fix-syntax-error.patch
  * d/control: declare Rules-Requires-Root: no

  [ Henry-Nicolas Tourneur ]
  * d/rules: leverage debhelper-compat 13 by using execute_after and _before
    Replace override statements, PYBUILD_BEFORE_BUILD and PYBUILD_AFTER_INSTALL
  * d/copyright: cleanup files field paths.
  * d/copyright: update to reflect new upstream version.
  * Remove patch no longer used for oldstable: 2000-backport-to-stretch.patch
  * Exclude from upstream tarball prebuilt static js sphinx theme files.
  * Remove README files of SelfTest that are installed under /usr/lib/python

 -- Johannes 'josch' Schauer <josch@debian.org>  Thu, 14 May 2020 21:03:10 +0200

=== debian/control ===
--- 
+++ 
@@ -3,19 +3,17 @@
 Uploaders: Christopher Hoskin <mans0954@debian.org>
 Section: python
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 13),
                dh-python,
-               python-all-dev,
-               python-setuptools,
                python3-all-dev,
                python3-setuptools,
-               python3-sphinx,
-               python3-sphinx-rtd-theme
-Standards-Version: 3.9.8
+               python3-sphinx <!nodoc>,
+               python3-sphinx-rtd-theme <!nodoc>,
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: http://www.pycryptodome.org
 Vcs-Git: https://salsa.debian.org/python-team/modules/pycryptodome.git
 Vcs-Browser: https://salsa.debian.org/python-team/modules/pycryptodome
-
 
 Package: python3-pycryptodome
 Architecture: any
@@ -54,3 +52,40 @@
  .
  This is the Python 3 version of the package.
 
+Package: python-pycryptodome-doc
+Architecture: all
+Section: doc
+Depends: ${misc:Depends}, ${sphinxdoc:Depends}, python3-sphinx-rtd-theme
+Description: cryptographic Python library (documentation)
+ PyCryptodome is a self-contained Python package of low-level
+ cryptographic primitives.
+ .
+ PyCryptodome is a fork of PyCrypto. It brings several enhancements
+ with respect to the last official version of PyCrypto (2.6.1),
+ for instance:
+ .
+   * Authenticated encryption modes (GCM, CCM, EAX, SIV, OCB)
+   * Accelerated AES on Intel platforms via AES-NI
+   * First class support for PyPy
+   * Elliptic curves cryptography (NIST P-256 curve only)
+   * Better and more compact API (`nonce` and `iv` attributes for ciphers,
+     automatic generation of random nonces and IVs, simplified CTR cipher mode,
+     and more)
+   * SHA-3 (including SHAKE XOFs) and BLAKE2 hash algorithms
+   * Salsa20 and ChaCha20 stream ciphers
+   * scrypt and HKDF
+   * Deterministic (EC)DSA
+   * Password-protected PKCS#8 key containers
+   * Shamir's Secret Sharing scheme
+   * Random numbers get sourced directly from the OS (and not from a CSPRNG in
+     userspace)
+   * Simplified install process, including better support for Windows
+   * Cleaner RSA and DSA key generation (largely based on FIPS 186-4)
+   * Major clean ups and simplification of the code base
+ .
+ PyCryptodome is not a wrapper to a separate C library like *OpenSSL*.
+ To the largest possible extent, algorithms are implemented in pure Python.
+ Only the pieces that are extremely critical to performance (e.g. block ciphers)
+ are implemented as C extensions.
+ .
+ This is the documentation package.

=== debian/tests/control ===
Test-Command: set -e ; for py in $(py3versions -r 2>/dev/null) ; do cd "$AUTOPKGTEST_TMP" ; echo "Testing with $py:" ; $py -c "import Cryptodome; print(Cryptodome)" ; done
Depends: python3-all, python3-pycryptodome

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1,uversionmangle=s/(rc|a|b|c)/~$1/,pgpsigurlmangle=s/$/.asc/ \
https://pypi.debian.net/pycryptodome/pycryptodome-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## pycryptodome 3.11.0%2Bdfsg1

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: pycryptodome
-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
+Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Christopher Hoskin <mans0954@debian.org>
 Section: python
 Priority: optional
@@ -9,11 +9,12 @@
                python3-setuptools,
                python3-sphinx <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
-Homepage: http://www.pycryptodome.org
-Vcs-Git: https://salsa.debian.org/python-team/modules/pycryptodome.git
-Vcs-Browser: https://salsa.debian.org/python-team/modules/pycryptodome
+Homepage: https://www.pycryptodome.org
+Vcs-Git: https://salsa.debian.org/python-team/packages/pycryptodome.git
+Vcs-Browser: https://salsa.debian.org/python-team/packages/pycryptodome
+Testsuite: autopkgtest-pkg-python
 
 Package: python3-pycryptodome
 Architecture: any
@@ -28,20 +29,21 @@
  .
    * Authenticated encryption modes (GCM, CCM, EAX, SIV, OCB)
    * Accelerated AES on Intel platforms via AES-NI
-   * First class support for PyPy
-   * Elliptic curves cryptography (NIST P-256 curve only)
+   * Elliptic curves cryptography (NIST P-256, P-384 and P-521 curves only)
    * Better and more compact API (`nonce` and `iv` attributes for ciphers,
      automatic generation of random nonces and IVs, simplified CTR cipher mode,
      and more)
-   * SHA-3 (including SHAKE XOFs) and BLAKE2 hash algorithms
-   * Salsa20 and ChaCha20 stream ciphers
-   * scrypt and HKDF
+   * SHA-3 (including SHAKE and cSHAKE XOFs), truncated SHA-512 and BLAKE2
+     hash algorithms
+   * Salsa20 and ChaCha20/XChaCha20 stream ciphers
+   * Poly1305 MAC
+   * ChaCha20-Poly1305 and XChaCha20-Poly1305 authenticated ciphers
+   * scrypt, bcrypt and HKDF derivation functions
    * Deterministic (EC)DSA
    * Password-protected PKCS#8 key containers
    * Shamir's Secret Sharing scheme
-   * Random numbers get sourced directly from the OS (and not from a CSPRNG in
-     userspace)
-   * Simplified install process, including better support for Windows
+   * Random numbers get sourced directly from the OS (and not from a CSPRNG
+     in userspace)
    * Cleaner RSA and DSA key generation (largely based on FIPS 186-4)
    * Major clean ups and simplification of the code base
  .
@@ -66,20 +68,21 @@
  .
    * Authenticated encryption modes (GCM, CCM, EAX, SIV, OCB)
    * Accelerated AES on Intel platforms via AES-NI
-   * First class support for PyPy
-   * Elliptic curves cryptography (NIST P-256 curve only)
+   * Elliptic curves cryptography (NIST P-256, P-384 and P-521 curves only)
    * Better and more compact API (`nonce` and `iv` attributes for ciphers,
      automatic generation of random nonces and IVs, simplified CTR cipher mode,
      and more)
-   * SHA-3 (including SHAKE XOFs) and BLAKE2 hash algorithms
-   * Salsa20 and ChaCha20 stream ciphers
-   * scrypt and HKDF
+   * SHA-3 (including SHAKE and cSHAKE XOFs), truncated SHA-512 and BLAKE2
+     hash algorithms
+   * Salsa20 and ChaCha20/XChaCha20 stream ciphers
+   * Poly1305 MAC
+   * ChaCha20-Poly1305 and XChaCha20-Poly1305 authenticated ciphers
+   * scrypt, bcrypt and HKDF derivation functions
    * Deterministic (EC)DSA
    * Password-protected PKCS#8 key containers
    * Shamir's Secret Sharing scheme
-   * Random numbers get sourced directly from the OS (and not from a CSPRNG in
-     userspace)
-   * Simplified install process, including better support for Windows
+   * Random numbers get sourced directly from the OS (and not from a CSPRNG
+     in userspace)
    * Cleaner RSA and DSA key generation (largely based on FIPS 186-4)
    * Major clean ups and simplification of the code base
  .

## pycryptodome 3.11.0+dfsg1

=== src/test/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 TAPPS:=tests_addmul128_32 tests_addmul128_64 tests_square_32 tests_square_64 tests_product tests_addmul test_endianess\
        test_poly1305_reduce test_poly1305_load_r test_poly1305_load_m test_poly1305_multiply test_poly1305_accumulate\
-	   test_mont tests_mont_mult tests_ec_ws_64 tests_ec_ws_32
+       test_mont tests_mont_mult tests_ec_ws_64 tests_ec_ws_32 test_pkcs1
 
 ifneq (,$(filter $(shell uname -m),x86_64 i386 i686))
 CPPFLAGS += -DHAVE_X86INTRIN_H -DUSE_SSE2 -DHAVE_WMMINTRIN_H -DHAVE_TMMINTRIN_H
@@ -44,10 +44,21 @@
 
 # ECC
 
-build/tests_ec_ws_64: test_ec_ws.c ../ec_ws.c build/mont_64.o $(UTILS)
+TABLES = build/p256_table.o build/p384_table.o build/p521_table.o
+
+build/p256_table.o: ../p256_table.c
+	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ $^
+
+build/p384_table.o: ../p384_table.c
+	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ $^
+
+build/p521_table.o: ../p521_table.c
+	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ $^
+
+build/tests_ec_ws_64: test_ec_ws.c ../ec_ws.c build/mont_64.o $(TABLES) $(UTILS)
 	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^
 
-build/tests_ec_ws_32: test_ec_ws.c ../ec_ws.c build/mont_32.o $(UTILS)
+build/tests_ec_ws_32: test_ec_ws.c ../ec_ws.c build/mont_32.o $(TABLES) $(UTILS)
 	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=32 -UHAVE_UINT128
 
 # addmul128
@@ -148,3 +159,7 @@
 
 build/tests_mont_mult: build/tests_mont_mult.c build/mont_32.o $(UTILS)
 	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^
+
+# pkcs1
+build/test_pkcs1: test_pkcs1.c ../common.h ../pkcs1_decode.c
+	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^

=== debian/changelog ===
pycryptodome (3.11.0+dfsg1-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Update lintian override info to new format: + debian/python3-pycryptodome.lintian-overrides: line 5-6 + debian/python-pycryptodome-doc.lintian-overrides: line 4
  * Update standards version to 4.6.1, no changes needed.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 16 Nov 2022 10:11:04 +0000

pycryptodome (3.11.0+dfsg1-3) unstable; urgency=medium

  * Team upload.
  * Limit the autopkgtest dependencies to just the module package, fixing test
    failure on i386 in Ubuntu.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 26 Nov 2021 11:13:48 -0400

pycryptodome (3.11.0+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Patch: Correct types in mont_select() declaration in C tests.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 15 Nov 2021 22:50:40 -0800

pycryptodome (3.11.0+dfsg1-1) unstable; urgency=medium

  * Team upload.
  [ Ondřej Nový ]
  * d/control: Update Maintainer field with new Debian Python Team
    contact address.
  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
    layout.

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Update renamed lintian tag names in lintian overrides.
  * Remove obsolete field Name from debian/upstream/metadata,
    already present in machine-readable debian/copyright.

  [ Håvard Flaget Aasen ]
  * New upstream version 3.11.0+dfsg1 Closes: #998094
  * Rebase patches
  * Mark autopkgtest as superficial. Closes: #974462
  * Patch to add compatibility with sphinx >= 4.0 Closes: #997733
  * Update lintian-overrides, use wildcard and capitalize word.
  * d/upstream/metadata: Remove registration link to GitHub.
  * d/changelog: Fix spelling mistake.
  * d/control:
    - Update Standards-Version to 4.6.0
    - Update the long description.
  * d/rules: Remove deleting of files. These files are no longer
    shipped with source from PyPI.
  * d/copyright: Update files and copyright year.

  [ Stefano Rivera ]
  * Remove noop proxy exports from debian/rules. pybuild automatically exports
    them, anyway.
  * Replace superficial autopkgtest with autodep8 configuration.
  * Add an autopkgtest to run the full test suite.
  * Run C test suite at build time:
    - Patch: Allow specifying the python binary for C tests.
    - Patch: Avoid creating a 0-length array during tests.

 -- Håvard Flaget Aasen <haavard_aasen@yahoo.no>  Sun, 14 Nov 2021 01:50:58 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PYBUILD_NAME=pycryptodome

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_test:
	PYBUILD_SYSTEM=custom \
        PYBUILD_TEST_ARGS="python{version} -m Cryptodome.SelfTest {build_dir}/" dh_auto_test
	$(MAKE) -C src/test PYTHON=python3

execute_before_dh_auto_build:
	touch .separate_namespace

execute_after_dh_auto_build:
	PYTHONPATH=. python3 -m sphinx -N -bhtml Doc/ build/html # HTML generator
	PYTHONPATH=. python3 -m sphinx -N -bman Doc/ build/man # Manpage generator

# Do this until it becomes clearer where documentation should live post Python 2
override_dh_installdocs:
	dh_installdocs -p python3-pycryptodome
	dh_installdocs --doc-main-package=python-pycryptodome-doc -p python-pycryptodome-doc

=== debian/tests/control ===
Tests: unittests
Depends: python3-all, python3-pycryptodome
Restrictions: allow-stderr

## pycryptodome 3.20.0+dfsg

=== Doc/requirements.txt ===
sphinx==7.1.0

=== src/Makefile ===
CPPFLAGS=-DHAVE_STDINT_H -DHAVE_POSIX_MEMALIGN -DPYCRYPTO_LITTLE_ENDIAN -DHAVE_X86INTRIN_H -DUSE_SSE2 -DHAVE_UINT128
CPPFLAGS += -DSTATIC=""
CFLAGS=-Werror -Wall -O3 -g -Wno-unused-const-variable -Wconversion -Wsign-conversion # -m32 -msse2

all:: modexp ec_ws_p256 ec_ws_p384 ec_ws_p521 ed25519_perf ed448_perf

ec_ws_p256: ec_ws_p256.c mont.c p256_table.c p384_table.c p521_table.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=64 -DMAIN

ec_ws_p384: ec_ws_p384.c mont.c p256_table.c p384_table.c p521_table.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=64 -DMAIN

ec_ws_p521: ec_ws_p521.c mont.c p256_table.c p384_table.c p521_table.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=64 -DMAIN

ed25519_perf: ed25519_perf.c multiply_64.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=64 -DMAIN

ed448_perf: ed448_perf.c mont.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=64 -DMAIN

modexp_in: modexp.c mont.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=64 -DMAIN

modexp: modexp.c mont.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=64 -DPROFILE

p256_table.c: make_ecc_table.py
	python make_ecc_table.py p256 5 p256_table

p384_table.c: make_ecc_table.py
	python make_ecc_table.py p384 5 p384_table

p521_table.c: make_ecc_table.py
	python make_ecc_table.py p521 4 p521_table

x25519: x25519.c multiply_64.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^ -DSYS_BITS=64 -DPROFILE

clean::
	rm -f ec_ws_p256 ec_ws_p384 ec_ws_p521 mont.o modexp x25519 ed25519_perf ed448_perf

=== debian/changelog ===
pycryptodome (3.20.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release (Closes: #1056436)
    - C unit tests also run on non-x86 architectures
      (Closes: #1053328, LP: #2039968)
  * Drop patches applied upstream

 -- Benjamin Drung <bdrung@debian.org>  Thu, 11 Jan 2024 14:32:40 +0100

pycryptodome (3.18.0+dfsg1-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * d/watch:
    - Pull fron github repo instead of pypi.debian.net
    - Verify signature with uscan
  * d/rules:
    - Update to build src/test files with cmake
    - Update dh_auto_test to run for all supported python versions
  * d/control:
    - Add cmake to Build-Depends
    - Bump standards version to 4.6.2 from 4.6.1
  * d/copyright:
    - Update copyright year to 2023 for debian/* files
    - Add myself to copyright for debian/* files
  * d/tests/unittests:
    - Correct py3versions from -r option to -s
    - Remove redirection to /dev/null
  * d/patches/: Update existing patches
    - Update 0001-Fix-Documentation.patch
      + Additional images to remove
    - Remove 0003-sphinx-compatibility.patch
      + Fixed in upstream
    - Remove 0004-Permit-easy-selection-of-a-python-binary-in-the-C-te.patch
      + Makefile no longer exists
    - Remove 0005-C-Tests-Avoid-creating-a-0-length-array
      + Fixed in upstream
    - Rename 0006-The-final-argument-to-mont_select-is-a-size_t.patch to
      0003-The-final-argument-to-mod_select-is-a-size_t.patch
      + Function renamed, type error still exists, updated Forwarded
  * d/source/lintian-overrides:
    - Override long line lengths
    - Override unnecessary check for DEB_BUILD_OPTIONS
  * d/upstream/metadata:
    - Update Archive from Pypi to Github

 -- Ileana Dumitrescu <ileanadumitrescu95@gmail.com>  Mon, 10 Jul 2023 19:53:57 +0300

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Uploaders: Christopher Hoskin <mans0954@debian.org>
 Section: python
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: cmake,
+               debhelper-compat (= 13),
                dh-python,
                python3-all-dev,
                python3-setuptools,
                python3-sphinx <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://www.pycryptodome.org
 Vcs-Git: https://salsa.debian.org/python-team/packages/pycryptodome.git

=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,11 @@
 	dh $@ --with python3,sphinxdoc --buildsystem=pybuild
 
 override_dh_auto_test:
-	PYBUILD_SYSTEM=custom \
-        PYBUILD_TEST_ARGS="python{version} -m Cryptodome.SelfTest {build_dir}/" dh_auto_test
-	$(MAKE) -C src/test PYTHON=python3
+	for PY3VER in $(shell py3versions -sv); do \
+		PYBUILD_SYSTEM=custom \
+			PYBUILD_TEST_ARGS="python$$PY3VER -m Cryptodome.SelfTest {build_dir}/" dh_auto_test; \
+	done
+	cd src/test && export PYTHON=python3 && cmake -DPYTHON=${PYTHON} && $(MAKE)
 
 execute_before_dh_auto_build:
 	touch .separate_namespace
